local timeout = tonumber(c8y.config:value("timeout", 60))

--TODO clean up code copying
function rdbGet(parameter)
  local file = io.popen("rdb get " .. parameter)
  local result
  if file then
    result = file:read("*l")
    file:close()
  end
  return result
end

function rdbSet(parameter, value)
  local file = io.popen("rdb set " .. parameter .. " " .. value)
  if file then
    file:close()
  end
end

function rdbSetFlags(parameter, flags)
  local file = io.popen("rdb setflags " .. parameter .. " " .. flags)
  if file then
    file:close()
  end
end

function findLinkProfile()
  local result
  for index=1, 6 do
    result = rdbGet("link.profile." .. index .. ".defaultroute")
    if result == "1" then
      return index
    end
  end
  return nil
end

function setPdp(onOff)
  local linkProfile = findLinkProfile()
  if linkProfile then
    print("SETTING PDP TO " .. onOff)
    rdbSet("link.profile." .. linkProfile .. ".enable", onOff)
    return true
  end
end
-------------------------------------------------------------------
class("ModeSetter")

function ModeSetter:operationExecuting(op)
  local mode = op:getResponseRecord(1)[3]
  if mode:lower() == "sms" then
    rdbSet("service.cumulocity.sms.enable",1)
    rdbSetFlags("service.cumulocity.sms.enable", "p")
    local startTime = os.time()
    local opId = op.id
    c8y.timer.singleShot(timeout, function(timer)
      local confirm = rdbGet("service.cumulocity.modeswitching.confirm")
      if confirm == "1" then
        local confirm = rdbSet("service.cumulocity.modeswitching.confirm", 0)
        timer:stop()
      else
        rdbSet("service.cumulocity.sms.enable",0)
        c8y.operations:setOperationStatus(opId, c8y.operations.Failed, "Switching to SMS mode failed.")
        timer:stop()
      end
    end)
  else
    op:setStatus(op.Failed, "Switching to communcation mode " .. (mode or "nil") .. " not supported.")
  end
end
-------------------------------------------------------------------

function watchSmsAgentTermination()
	print("WATCHING FOR SMS AGENT TO TERMINATE")
  c8y.timer.start(5, function(timer)
    local smsEnable = rdbGet("service.cumulocity.sms.enable")
    if smsEnable == "0" then
      print("SMS AGENT TERMINATED")
      setPdp(1)
      watchSmsAgentStart()
      timer:stop()
    end
  end)
end

function watchSmsAgentStart()
	print("WATCHING FOR SMS AGENT TO START")
  c8y.timer.start(5, function(timer)
    local confirm = rdbGet("service.cumulocity.modeswitching.confirm")
    if confirm == "1" then
      print("SMS AGENT START CONFIRMED")
      setPdp(0)
      watchSmsAgentTermination()
      timer:stop()
    end
  end)
end

function init()
  local modeSetter = ModeSetter()
  c8y.operations:addOperation("c8y_CommunicationMode", "$.mode", modeSetter)

  watchSmsAgentStart()
end
